Date: Tue, 23 Feb 2010 05:59:42 -0500
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: multipart/mixed;
  boundary="=_multipart_boundary_17"

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=8;
  lastmodified=1266922782;
  created=1266922782;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
#!/bin/bash

# Digest a single number into a pretty number
pretty(){
  # Initialization
  num=${1:-0}
  zero=0
  tera_mag=1099511627776
  giga_mag=1073741824
  mega_mag=1048576
  kilo_mag=1024
  byte_mag=1

  # Scale down to appropriate magnitude
  tera=$(( $num / ${tera_mag} ))
  num=$(( $num % ${tera_mag} ))
  giga=$(( $num / ${giga_mag} ))
  num=$(( $num % ${giga_mag} ))
  mega=$(( $num / ${mega_mag} ))
  num=$(( $num % ${mega_mag} ))
  kilo=$(( $num / ${kilo_mag} ))
  num=$(( $num % ${kilo_mag} ))
  byte=${num:-0}

  # Select proper magnitude and suffix
  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && suffix=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && suffix=MB
  [ $giga -gt 0 ] && one=giga && two=mega && suffix=GB
  [ $tera -gt 0 ] && one=tera && two=giga && suffix=TB

  # Compute float
  whole=$(eval echo \$$one)
  part=$(eval echo \$$two)
  num=$(printf "%s.%s" "${whole}" "${part}")

  # Compute printf format
  fmt="%0.2f%s\n"
  [ "${whole}" -gt 9 ] && fmt="%0.1f%s\n"
  [ "${whole}" -gt 99 ] && fmt="%0.0f%s\n"
  [ "${two}" = "zero" ] && fmt="%0.0f%s\n"

  # Generate result
  printf "${fmt}" "${num}" "${suffix}"
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</code>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=7;
  lastmodified=1266920600;
  created=1266922782;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
#!/bin/bash

# Digest a single number into a pretty number
pretty(){
  # Initialization
  num=${1:-0}
  zero=0
  tera_mag=1099511627776
  giga_mag=1073741824
  mega_mag=1048576
  kilo_mag=1024
  byte_mag=1

  # Scale down to appropriate magnitude
  tera=$(( $num / ${tera_mag} ))
  num=$(( $num % ${tera_mag} ))
  giga=$(( $num / ${giga_mag} ))
  num=$(( $num % ${giga_mag} ))
  mega=$(( $num / ${mega_mag} ))
  num=$(( $num % ${mega_mag} ))
  kilo=$(( $num / ${kilo_mag} ))
  num=$(( $num % ${kilo_mag} ))
  byte=${num:-0}

  # Select proper magnitude and suffix
  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && suffix=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && suffix=MB
  [ $giga -gt 0 ] && one=giga && two=mega && suffix=GB
  [ $tera -gt 0 ] && one=tera && two=giga && suffix=TB

  # Compute float
  whole=$(eval echo \$$one)
  part=$(eval echo \$$two)
  part_mag=$(eval echo \$${two}_mag)
  part=$(( ( ${part:-0} * 100 ) / $(eval echo \$${two}_mag) ))
  num=$(printf "%s.%s" "${whole}" "${part}")

  # Compute printf format
  fmt="%0.2f%s\n"
  [ "${whole}" -gt 9 ] && fmt="%0.1f%s\n"
  [ "${whole}" -gt 99 ] && fmt="%0.0f%s\n"
  [ "${two}" = "zero" ] && fmt="%0.0f%s\n"

  # Generate result
  printf "${fmt}" "${num}" "${suffix}"
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</code>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=6;
  lastmodified=1256041334;
  created=1266920600;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
#!/bin/bash

pretty(){
  # Digest a single number into a pretty number
  num=${1:-0}
  zero=0

  tera=$(( $num / 1099511627776 ))
  num=$(( $num % 1099511627776 ))
  giga=$(( $num / 1073741824 ))
  num=$(( $num % 1073741824 ))
  mega=$(( $num / 1048576 ))
  num=$(( $num % 1048576 ))
  kilo=$(( $num / 1024 ))
  num=$(( $num % 1024 ))
  byte=${num:-0}

  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && sign=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && sign=MB
  [ $giga -gt 0 ] && one=giga && two=mega && sign=GB
  [ $tera -gt 0 ] && one=tera && two=giga && sign=TB

  fmt="%0.2f%s\n"
  [ "${sign}" = "B" ] && fmt="%0d%s\n"
  num=$(eval echo \$$one.\$$two)
  [ "$two" = "zero" ] && num=$(eval echo \$$one)
  printf "${fmt}" ${num} $sign
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</code>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=5;
  lastmodified=1244913277;
  created=1256041334;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<verbatim>
#!/bin/bash

pretty(){
  # Digest a single number into a pretty number
  num=${1:-0}
  zero=0

  tera=$(( $num / 1099511627776 ))
  num=$(( $num % 1099511627776 ))
  giga=$(( $num / 1073741824 ))
  num=$(( $num % 1073741824 ))
  mega=$(( $num / 1048576 ))
  num=$(( $num % 1048576 ))
  kilo=$(( $num / 1024 ))
  num=$(( $num % 1024 ))
  byte=${num:-0}

  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && sign=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && sign=MB
  [ $giga -gt 0 ] && one=giga && two=mega && sign=GB
  [ $tera -gt 0 ] && one=tera && two=giga && sign=TB

  fmt="%0.2f%s\n"
  [ "${sign}" = "B" ] && fmt="%0d%s\n"
  num=$(eval echo \$$one.\$$two)
  [ "$two" = "zero" ] && num=$(eval echo \$$one)
  printf "${fmt}" ${num} $sign
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</verbatim>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=4;
  lastmodified=1244911110;
  created=1244913277;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<verbatim>
#!/bin/bash

pretty(){
  # Digest a single number into a pretty number
  num=$1
  zero=0

  tera=$(( $num / 1099511627776 ))
  num=$(( $num % 1099511627776 ))
  giga=$(( $num / 1073741824 ))
  num=$(( $num % 1073741824 ))
  mega=$(( $num / 1048576 ))
  num=$(( $num % 1048576 ))
  kilo=$(( $num / 1024 ))
  num=$(( $num % 1024 ))
  byte=${num:-0}

  one=${byte} && two=${zero} && sign=B
  [ $kilo -gt 0 ] && one=${kilo} && two=${byte} && sign=kB
  [ $mega -gt 0 ] && one=${mega} && two=${kilo} && sign=MB
  [ $giga -gt 0 ] && one=${giga} && two=${mega} && sign=GB
  [ $tera -gt 0 ] && one=${tera} && two=${giga} && sign=TB

  fmt="%0.2f%s\n"
  [ "${sign}" = "B" ] && fmt="%0d%s\n"
  if [ "${two}" = "${zero}" ]
  then
    num="${one}"
  else
    num="$(eval echo \$$one.\$$two)"
  fi
  printf "${fmt}" ${num} $sign
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</verbatim>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=3;
  lastmodified=1228922921;
  created=1244911110;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<verbatim>
#!/bin/bash

pretty(){
  # Digest a single number into a pretty number
  num=$1
  zero=000

  tera=$(( $num / 1099511627776 ))
  num=$(( $num % 1099511627776 ))
  giga=$(( $num / 1073741824 ))
  num=$(( $num % 1073741824 ))
  mega=$(( $num / 1048576 ))
  num=$(( $num % 1048576 ))
  kilo=$(( $num / 1024 ))
  num=$(( $num % 1024 ))
  byte=${num:-0}

  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && sign=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && sign=MB
  [ $giga -gt 0 ] && one=giga && two=mega && sign=GB
  [ $tera -gt 0 ] && one=tera && two=giga && sign=TB

  fmt="%0.2f%s\n"
  [ "${sign}" = "B" ] && fmt="%0d%s\n"
  printf "${fmt}" $(eval echo \$$one.\$$two) $sign
}

digest(){
  dev="${1}"
  if [ ! -d "/sys/block/${dev}" ]
  then
    return 1
  fi
  eval $(printf 'old_r=$old_r_%s old_w=$old_w_%s' "${dev}" "${dev}")
  [ -z "${old_r}" ] && old_r=0
  [ -z "${old_w}" ] && old_w=0
  eval $(awk '{print "cur_r=" $3 " cur_w=" $7}' /sys/block/${dev}/stat)
  dif_r=$(( (${cur_r} - ${old_r}) * 512 ))
  dif_w=$(( (${cur_w} - ${old_w}) * 512 ))
  eval $(printf "old_r_%s=%u old_w_%s=%u" "${dev}" "${cur_r}" "${dev}" "${cur_w}")
  printf "%s: R: %s W: %s \033[K\n" "${dev}" "$(pretty ${dif_r})" "$(pretty ${dif_w})"
}

while true
do
  printf "\033[0;0H" # Cursor to upper left
  for I in /sys/block/sd?
  do
    digest "$(basename "${I}")"
  done
  printf "\033[0J" # Clear the rest of the page
  sleep 1
done

</verbatim>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=2;
  lastmodified=1226821450;
  created=1228922921;
  author_id=CyberLeo;
  summary=Fix%20a%20bug%20with%20%2Fsys%2Fblock%2F%3Cdev%3E%2Fstat%20parsing;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<verbatim>
#!/bin/bash

sda_r=0
sda_w=0
sda_r_old=0
sda_w_old=0
sdb_r=0
sdb_w=0
sdb_r_old=0
sdb_w_old=0
sdc_r=0
sdc_w=0
sdc_r_old=0
sdc_w_old=0
sdd_r=0
sdd_w=0
sdd_r_old=0
sdd_w_old=0
md0_r=0
md0_w=0
md0_r_old=0
md0_w_old=0

pretty(){
  # Digest a single number into a pretty number
  num=$1
  zero=000

  tera=$(( $num / 1099511627776 ))
  num=$(( $num % 1099511627776 ))
  giga=$(( $num / 1073741824 ))
  num=$(( $num % 1073741824 ))
  mega=$(( $num / 1048576 ))
  num=$(( $num % 1048576 ))
  kilo=$(( $num / 1024 ))
  num=$(( $num % 1024 ))
  byte=${num:-0}

  one=byte && two=zero && sign=B
  [ $kilo -gt 0 ] && one=kilo && two=byte && sign=kB
  [ $mega -gt 0 ] && one=mega && two=kilo && sign=MB
  [ $giga -gt 0 ] && one=giga && two=mega && sign=GB
  [ $tera -gt 0 ] && one=tera && two=giga && sign=TB

  printf "%0.2f %s\n" $(eval echo \$$one.\$$two) $sign
}

while true
do
  # Get new values
  eval $(awk '{print "sda_r=" $3 " sda_w=" $7}' /sys/block/sda/stat)
  eval $(awk '{print "sdb_r=" $3 " sdb_w=" $7}' /sys/block/sdb/stat)
  eval $(awk '{print "sdc_r=" $3 " sdc_w=" $7}' /sys/block/sdc/stat)
  eval $(awk '{print "sdd_r=" $3 " sdd_w=" $7}' /sys/block/sdd/stat)
  eval $(awk '{print "md0_r=" $3 " md0_w=" $7}' /sys/block/md0/stat)


  # Compute diffs
  sda_r_diff=$(( ($sda_r - $sda_r_old) * 512))
  sda_w_diff=$(( ($sda_w - $sda_w_old) * 512))
  sdb_r_diff=$(( ($sdb_r - $sdb_r_old) * 512))
  sdb_w_diff=$(( ($sdb_w - $sdb_w_old) * 512))
  sdc_r_diff=$(( ($sdc_r - $sdc_r_old) * 512))
  sdc_w_diff=$(( ($sdc_w - $sdc_w_old) * 512))
  sdd_r_diff=$(( ($sdd_r - $sdd_r_old) * 512))
  sdd_w_diff=$(( ($sdd_w - $sdd_w_old) * 512))
  md0_r_diff=$(( ($md0_r - $md0_r_old) * 512))
  md0_w_diff=$(( ($md0_w - $md0_w_old) * 512))

  # Print the display
  printf "\033[0;0H"
  printf "sda: %12s %12s \033[K\n" "$(pretty $sda_r_diff)" "$(pretty $sda_w_diff)"
  printf "sdb: %12s %12s \033[K\n" "$(pretty $sdb_r_diff)" "$(pretty $sdb_w_diff)"
  printf "sdc: %12s %12s \033[K\n" "$(pretty $sdc_r_diff)" "$(pretty $sdc_w_diff)"
  printf "sdd: %12s %12s \033[K\n" "$(pretty $sdd_r_diff)" "$(pretty $sdd_w_diff)"
  printf "md0: %12s %12s \033[K\n" "$(pretty $md0_r_diff)" "$(pretty $md0_w_diff)"

  # Save values
  sda_r_old=$sda_r
  sda_w_old=$sda_w
  sdb_r_old=$sdb_r
  sdb_w_old=$sdb_w
  sdc_r_old=$sdc_r
  sdc_w_old=$sdc_w
  sdd_r_old=$sdd_r
  sdd_w_old=$sdd_w
  md0_r_old=$md0_r
  md0_w_old=$md0_w

  # Sleep until the next cycle
  sleep 1
done
</verbatim>

--=_multipart_boundary_17
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fdiskstats.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=1;
  lastmodified=1191472095;
  created=1226821450;
  author_id=CyberLeo;
  hits=2529;
  charset=UTF-8
Content-Transfer-Encoding: binary

<verbatim>
#!/bin/bash

sdb_r=0
sdb_w=0
sdb_r_old=0
sdb_w_old=0
sdc_r=0
sdc_w=0
sdc_r_old=0
sdc_w_old=0

pretty(){
	# Digest a single number into a pretty number
	num=$1
	zero=000

	tera=$(( $num / 1099511627776 ))
	num=$(( $num % 1099511627776 ))
	giga=$(( $num / 1073741824 ))
	num=$(( $num % 1073741824 ))
	mega=$(( $num / 1048576 ))
	num=$(( $num % 1048576 ))
	kilo=$(( $num / 1024 ))
	num=$(( $num % 1024 ))
	byte=${num:-0}

	one=byte && two=zero && sign=B
	[ $kilo -gt 0 ] && one=kilo && two=byte && sign=kB
	[ $mega -gt 0 ] && one=mega && two=kilo && sign=MB
	[ $giga -gt 0 ] && one=giga && two=mega && sign=GB
	[ $tera -gt 0 ] && one=tera && two=giga && sign=TB

	printf "%0.2f %s\n" $(eval echo \$$one.\$$two) $sign
}

while true
do
	# Get new values
	eval $(printf 'sdb_r=%u sdb_w=%u' $(cat /sys/block/sdb/stat |tr -s ' ' | cut -d' ' -f4,8))
	eval $(printf 'sdc_r=%u sdc_w=%u' $(cat /sys/block/sdc/stat |tr -s ' ' | cut -d' ' -f4,8))

	# Compute diffs
	sdb_r_diff=$(( ($sdb_r - $sdb_r_old) * 512))
	sdb_w_diff=$(( ($sdb_w - $sdb_w_old) * 512))
	sdc_r_diff=$(( ($sdc_r - $sdc_r_old) * 512))
	sdc_w_diff=$(( ($sdc_w - $sdc_w_old) * 512))

	# Print the display
	printf "\r sdb: r %s w %s - sdc: r: %s w %s           " \
		"$(pretty $sdb_r_diff)" "$(pretty $sdb_w_diff)" \
		"$(pretty $sdc_r_diff)" "$(pretty $sdc_w_diff)"

	# Save values
	sdb_r_old=$sdb_r
	sdb_w_old=$sdb_w
	sdc_r_old=$sdc_r
	sdc_w_old=$sdc_w

	# Sleep until the next cycle
	sleep 1
done
</verbatim>

--=_multipart_boundary_17--
